import 'package:flutter_driver/driver_extension.dart';
import 'package:flutter_driver/flutter_driver.dart';
import 'package:flutter_driver_extension_extensions/src/finders/finders.dart';
import 'package:flutter_test/flutter_test.dart';

class AtExtension extends FinderExtension {
  @override
  Finder createFinder(
    SerializableFinder finder,
    CreateFinderFactory finderFactory,
  ) {
    final atFinder = (finder as AtFinder);
    final descendantFinder = finderFactory.createFinder(atFinder.finder);
    return descendantFinder.at(atFinder.n);
  }

  @override
  SerializableFinder deserialize(
    Map<String, String> params,
    DeserializeFinderFactory finderFactory,
  ) {
    return AtFinder.deserialize(params, finderFactory);
  }

  @override
  String get finderType => 'At';
}

class LastExtension extends FinderExtension {
  @override
  Finder createFinder(
    SerializableFinder finder,
    CreateFinderFactory finderFactory,
  ) {
    final atFinder = (finder as LastFinder);
    final descendantFinder = finderFactory.createFinder(atFinder.finder);
    return descendantFinder.last;
  }

  @override
  SerializableFinder deserialize(
    Map<String, String> params,
    DeserializeFinderFactory finderFactory,
  ) {
    return LastFinder.deserialize(params, finderFactory);
  }

  @override
  String get finderType => 'Last';
}
